#if !defined(__cplusplus)
#include <stdbool.h> /* C doesn't have booleans by default. */
#endif
#include <stddef.h>
#include <stdint.h>
 
/* Check if the compiler thinks if we are targeting the wrong operating system. */
#if defined(__linux__)
#error "You are not using a cross-compiler, you will most certainly run into trouble"
#endif
 
/* This tutorial will only work for the 32-bit ix86 targets. */
#if !defined(__i386__)
#error "This tutorial needs to be compiled with a ix86-elf compiler"
#endif

#define GDT_SIZE 3

struct sector
{
    uint16_t lo_limit;
    uint16_t lo_offset;
    uint8_t  mid_offset;
    uint8_t  type;
    uint8_t  granularity;
    uint8_t  hi_offset;
} __attribute__((packed));

struct gdt_location
{
    uint16_t  limit;
    uint32_t offset;
} __attribute__((packed));



void set_gdtp(void);
void init_gdt();
void print_gdt_entry(int i);
void construct_gdtp();
void encode_gdt_entry(int i, uint32_t offset, uint16_t limit, uint8_t type, uint8_t granularity);