#if !defined(__cplusplus)
#include <stdbool.h> /* C doesn't have booleans by default. */
#endif
#include <stddef.h>
#include <stdint.h>
 
/* Check if the compiler thinks if we are targeting the wrong operating system. */
#if defined(__linux__)
#error "You are not using a cross-compiler, you will most certainly run into trouble"
#endif
 
/* This tutorial will only work for the 32-bit ix86 targets. */
#if !defined(__i386__)
#error "This tutorial needs to be compiled with a ix86-elf compiler"
#endif

#define IDT_SIZE 256

struct interrupt_gate
{
    uint16_t lo_offset;
    uint16_t selector;
    uint8_t  zero;
    uint8_t  type;
    uint16_t hi_offset;
} __attribute__((packed));

struct idt_location
{
    uint16_t  limit;
    uint32_t offset;
} __attribute__((packed));



void set_idtp(void);
void init_idt();
void print_idt_entry(int i);
void construct_idtp();
void encode_idt_entry(int i, unsigned long offset, uint16_t selector, uint8_t type_attr);