#include "io/terminal.h"
#include "init/gdt.h"
#include "init/idt.h"

void kerror(const char* data)
{
	terminal_writestring(data);
}

void test1();

#if defined(__cplusplus)
extern "C" /* Use C linkage for kernel_main. */
#endif

void init_kernel()
{
    print("Starting Init\n");
    terminal_initialize();
    init_gdt();
    init_idt();
    print("Init Finished\n");
}

void kernel_main()
{
  asm("sti");
  print("Running Test 1\n");
  //test1();
	/* Since there is no support for newlines in terminal_putchar yet, \n will
	   produce some VGA specific character instead. This is normal. */
	terminal_writestring("Hello, kernel World!\n");
}
